<?php /* styling for this field */ ?>
<style>

    .sl_group:after {
        visibility: hidden;
        display: block;
        content: "";
        clear: both;
        height: 0;
    }

    * html .sl_group {
        zoom: 1;
    }

    /* IE6 */
    *:first-child + html .sl_group {
        zoom: 1;
    }

    /* IE7 */

    #supr3me-shortlinker-settings {
        display: none;
        padding-bottom: 10px;
        margin-bottom: 15px;
        border-bottom: 1px solid #EEE;
    }

    .text-fields INPUT {
        width: 48%;
        float: right;
    }

    .submit_grp {
        margin-top: 5px;
    }

    .submit_grp BUTTON {
        float: right;
    }

</style>


<?php if (current_user_can('manage_options')): ?>

    <form id="supr3me-shortlinker-settings" class="sl_group">

        <?php wp_nonce_field('save_shortlinker_settings', '__nonce'); ?>
        <input type="hidden" name="action" value="supr3me-shortlinker-settings-save">

        <div class="sl_group text-fields">
            <label for="api_url" style="float: left; width: 52%"><b>API URL</b></label>
            <label for="api_key" style="float: left; width: 48%"><b>API Key</b></label>
            <input type="url" required="required" name="api_url" id="api_url" placeholder="Enter API URL"
                   value="<?= esc_html($this->_options['apiurl']) ?>" style="width: 48%; float: left">
            <input type="text" required="required" name="api_key" id="api_key" minlength="32" maxlength="40"
                   placeholder="Enter API Key" value="<?= esc_html($this->_options['apikey']) ?>"
                   style="width: 48%; float: right">
        </div>

        <div class="sl_group submit_grp">
            <button type="submit" class="button button-primary">Save Settings</button>
        </div>

    </form>
<?php endif; ?>


<?php /* submission form */ ?>
<form id="supr3me-shortlinker-form">

    <?php wp_nonce_field('send_shortlinker_form', '__nonce'); ?>
    <input type="hidden" name="action" value="supr3me-shortlinker-generate">

    <input type="url" required="required" name="shortlink_url" id="shortlink_url" autocomplete="off"
           style="width: 75%; margin-right: 1% float: left" placeholder="URL to shrink">
    <button type="submit" name="shortlink_submit" id="shortlink_submit" class="button button-primary"
            style="float: right; width: 20%">Submit
    </button>

    <div class="clearfix"></div>
</form>


<? /* our javascript to execute */ ?>
<script>
    (function ($) {

        // set our form to be clean
        window.shortlinkerformdirty = false;

        // handle sliding the links
        $('.postbox#supr3me-short-linker A[href=#settings]').click(function (e) {

            // prevent default
            e.preventDefault();

            // toggle slide the settings
            $('#supr3me-shortlinker-settings').slideToggle('fast');
        });

        // handle dirty forms
        $('FORM#supr3me-shortlinker-settings INPUT').change(function () {
            window.shortlinkerformdirty = true;
        })

        // handle submitting the settings form
        $('FORM#supr3me-shortlinker-settings').submit(function (e) {

            // prevent default
            e.preventDefault();

            // check to make sure our form is dirty
            if (!window.shortlinkerformdirty) return;

            // get our different elements
            var $form = $(this);

            // execute ajax request
            var jqxhr = $.post(ajaxurl, $form.serializeArray());

            // disable all elements
            $('INPUT, BUTTON', $form).prop('disabled', true);

            // always do this
            jqxhr.always(function () {
                // re-enable the buttons & inputs
                $('INPUT, BUTTON', $form).prop('disabled', false);
            });

            // handle success case
            jqxhr.success(function (data) {
                window.shortlinkerformdirty = false;
                alert(data);
                $('#supr3me-shortlinker-settings').slideUp('fast');
            });

            // handle fail case
            jqxhr.fail(function () {
                alert('An unknown error occured. Please check connection to the server.');
            });
        });

        // handle submitting the shortlink form
        $('FORM#supr3me-shortlinker-form').submit(function (e) {

            // prevent default
            e.preventDefault();

            // setup our form
            var $form = $(this);

            // execute ajax request
            var jqxhr = $.post(ajaxurl, $form.serializeArray());

            // carry out our request
            $('INPUT, BUTTON', $form).prop('disabled', true);

            // always do this
            jqxhr.always(function () {
                $('INPUT, BUTTON', $form).prop('disabled', false);
            });

            // handle success case
            jqxhr.success(function (res) {
                if (res.success) {

                    // reset the form
                    $form.trigger('reset');

                    // great, display our prompt
                    return prompt('Short link created, copy below: ', res.data.link);

                } else {
                    // something went wrong
                    alert('Error: ' + res.message);
                }
            });

            // handle fail case
            jqxhr.fail(function (data) {
                alert('An unknown error occured, please check connection to the server.');
            });

        });

    })(jQuery);
</script>